/* wisc.java
 * Author: John Lenz <jelenz@wisc.edu>
 * (C) Copyright 2003 John Lenz

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

import java.io.*;

// Export Multiply and divide functions for WISC archetecture
class WiscPrint {
  public static void export(PrintWriter p) {

    p.print(".text\n");
    p.print("\n");
    p.print("#numbers to multiply reside in $v0 and $v1.  The result is returned in $6\n");
    p.print("multiply:\n");
    p.print("              sw $ra, 0($sp) #push $sp\n");
    p.print("              sub $sp, $sp, 1\n");
    p.print("              \n");
    p.print("              li $7, 0\n");
    p.print("              move $t0, $v0\n");
    p.print("              move $t1, $v1\n");
    p.print("              \n");
    p.print("              bltz $v0, v0_neg\n");
    p.print("              bltz $v1, v1_neg\n");
    p.print("              j end_mult_if\n");
    p.print("v0_neg:       bltz $v1, v0_v1_neg\n");
    p.print("              neg $t0, $t0\n");
    p.print("              li $7, 1\n");
    p.print("              j end_mult_if\n");
    p.print("v1_neg:       neg $t1, $t1\n");
    p.print("              li $7, 1\n");
    p.print("              j end_mult_if\n");
    p.print("v0_v1_neg:    neg $t0, $t0\n");
    p.print("              neg $t1, $t1\n");
    p.print("end_mult_if:\n");
    p.print("\n");
    p.print("              li $6, 0\n");
    p.print("              beqz $t0, mult_return\n");
    p.print("              beqz $t1, mult_return\n");
    p.print("              sub $t1, $t1, 1\n");
    p.print("mult_loop:\n");
    p.print("              add $6, $6, $t0\n");
    p.print("              bdne $t1,  mult_loop\n");
    p.print("\n");
    p.print("mult_return:\n");
    p.print("              beqz $7, mult_real_ret\n");
    p.print("              neg $6, $6\n");
    p.print("mult_real_ret:\n");
    p.print("              ld+ $ra, 1($sp)\n");
    p.print("              ret\n");
    p.print("\n");
    p.print("#divide two numbers $v0 $v1 result is returned in $6\n");
    p.print("divide:\n");
    p.print("              sw $ra, 0($sp) #push $sp\n");
    p.print("              sub $sp, $sp, 1\n");
    p.print("\n");
    p.print("              li $7, 0\n");
    p.print("              move $t0, $v0\n");
    p.print("              move $t1, $v1\n");
    p.print("              bltz $v0, v0_neg_div\n");
    p.print("              bltz $v1, v1_neg_div\n");
    p.print("              j end_div_if\n");
    p.print("v0_neg_div:   bltz $v1, v0_v1_neg_div\n");
    p.print("              neg $t0, $t0\n");
    p.print("              li $7, 1\n");
    p.print("              j end_div_if\n");
    p.print("v1_neg_div:   neg $t1, $t1\n");
    p.print("              li $7, 1\n");
    p.print("              j end_div_if\n");
    p.print("v0_v1_neg_div:neg $t0, $t0\n");
    p.print("              neg $t1, $t1\n");
    p.print("end_div_if:\n");
    p.print("\n");
    p.print("              li $6, 0\n");
    p.print("              beqz $t0, div_return\n");
    p.print("              li $6, -1\n");
    p.print("div_loop:     bltz $t0, div_end_loop\n");
    p.print("              sub $t0, $t0, $t1\n");
    p.print("              add $6, $6, 1\n");
    p.print("              b div_loop\n");
    p.print("div_end_loop: add $t0, $t0, $t1\n");
    p.print("div_return:\n");
    p.print("              beqz $7, div_real_ret\n");
    p.print("              neg $6, $6\n");
    p.print("div_real_ret: \n");
    p.print("              ld+ $ra, 1($sp)\n");
    p.print("              ret\n");
  }
};
